      SUBROUTINE PDGESVD3( SV, N, A, IA, JA, DESCA, S, U, IU, JU,
     $                     DESCU, VT, IVT, JVT, DESCVT, WORK, LWORK,
     $                     INFO )
*
* Scalar Arguments
      CHARACTER          SV
      INTEGER            IA, INFO, IU, IVT, JA, JU, JVT, LWORK, N
*
* Array Arguments
      INTEGER            DESCA( * ), DESCU( * ), DESCVT( * )
      DOUBLE PRECISION   A( * ), S( * ), U( * ), VT( * ), WORK( * )
*
* Parameters
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DTYPE_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_, ITHVAL
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9, ITHVAL = 10 )
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*
* Local Scalars
      CHARACTER          UPLO
      INTEGER            CONTEXTC, CONTEXTR, I, INDD, INDD2, INDE,
     $                   INDE2, INDTAUP, INDTAUQ, INDU, INDV, INDWORK,
     $                   IOFFD, IOFFE, ISCALE, J, K, LDU, LDVT, LLWORK,
     $                   LWMIN, MAXIM, MB, MP, MYPCOL, MYPCOLC, MYPCOLR,
     $                   MYPROW, MYPROWC, MYPROWR, NB, NCVT, NPCOL,
     $                   NPCOLC, NPCOLR, NPROCS, NPROW, NPROWC, NPROWR,
     $                   NQ, NRU, SIZEP, SIZEQ,
     $                   WANTU, WANTVT, WATOBD, WBDTOSVD, WDBDSQR,
     $                   WPDGEBRD, WPDLANGE, WPDORMBRPRT, WPDORMBRQLN
      DOUBLE PRECISION   ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN, SIGMA,
     $                   SMLNUM
*
* Local Arrays
      INTEGER            DESCTU( DLEN_ ), DESCTVT( DLEN_ ), IDUM1( 3 ),
     $                   IDUM2( 3 )
      DOUBLE PRECISION   C( 1, 1 )
*
* External Functions
      LOGICAL            LSAME
      INTEGER            NUMROC
      DOUBLE PRECISION   PDLAMCH, PDLANGE
      EXTERNAL           LSAME, NUMROC, PDLAMCH, PDLANGE
*
* External Subroutines
      EXTERNAL           BLACS_GET, BLACS_GRIDEXIT, BLACS_GRIDINFO,
     $                   BLACS_GRIDINIT, CHK1MAT, DBDSQR, DESCINIT,
     $                   DGAMN2D, DGAMX2D, DSCAL, IGAMX2D, IGEBR2D,
     $                   IGEBS2D, PCHK1MAT, PDGEBRD, PDGEMR2D,
     $                   PDLARED1D, PDLARED2D, PDLASCL, PDLASET,
     $                   PDORMBR, PXERBLA
*
* Intrinsic Functions
      INTRINSIC          DBLE, MAX, MIN, SQRT
*
* Executable Statements
*
      CALL BLACS_GRIDINFO( DESCA( CTXT_ ), NPROW, NPCOL, MYPROW,
     $                     MYPCOL )
      ISCALE = 0
      INFO = 0
*
      IF( NPROW.EQ.-1 ) THEN
         INFO = -( 600+CTXT_ )
      ELSE
*
         NPROCS = NPROW*NPCOL
         IOFFD = JA - 1
         IOFFE = IA - 1
*
         IF( LSAME( SV, 'R' ) ) THEN
            WANTU = 1
         ELSE
            WANTU = 0
         END IF
         IF( LSAME( SV, 'L' ) ) THEN
            WANTVT = 1
         ELSE
            WANTVT = 0
         END IF
*
         IF( LSAME( SV, 'A' ) ) THEN   
            WANTVT = 1
            WANTU = 1
         END IF
*
         CALL CHK1MAT( N, 2, N, 2, IA, JA, DESCA, 6, INFO )
         IF( WANTU.EQ.1 ) THEN
            CALL CHK1MAT( N, 2, N, 2, IU, JU, DESCU, 11, INFO)
         END IF
         IF( WANTVT.EQ.1 ) THEN
            CALL CHK1MAT( N, 2, N, 2, IVT, JVT, DESCVT, 15,
     $                    INFO )
         END IF
         CALL IGAMX2D( DESCA( CTXT_ ), 'A', ' ', 1, 1, INFO, 1, 1, 1,
     $                 -1, -1, 0 )
*
         IF( INFO.EQ.0 ) THEN
*
* Set up pointers into the WORK array.
*
            INDD = 2
            INDE = INDD + N + IOFFD
            INDD2 = INDE + N + IOFFE
            INDE2 = INDD2 + N + IOFFD
            INDTAUQ = INDE2 + N + IOFFE
            INDTAUP = INDTAUQ + N + JA - 1
            INDWORK = INDTAUP + N + IA - 1
            LLWORK = LWORK - INDWORK + 1
*
* Initialize contexts for "column" and "row" process matrices.
*
            CALL BLACS_GET( DESCA( CTXT_ ), 10, CONTEXTC )
            CALL BLACS_GRIDINIT( CONTEXTC, 'R', NPROCS, 1 )
            CALL BLACS_GRIDINFO( CONTEXTC, NPROWC, NPCOLC, MYPROWC,
     $                           MYPCOLC )
            CALL BLACS_GET( DESCA( CTXT_ ), 10, CONTEXTR )
            CALL BLACS_GRIDINIT( CONTEXTR, 'R', 1, NPROCS )
            CALL BLACS_GRIDINFO( CONTEXTR, NPROWR, NPCOLR, MYPROWR,
     $                           MYPCOLR )
*
* Set local dimensions of matrices (this is for MB=NB=1).
*
            NRU = NUMROC( N, 1, MYPROWC, 0, NPROCS )
            NCVT = NUMROC( N, 1, MYPCOLR, 0, NPROCS )
            NB = DESCA( NB_ )
            MB = DESCA( MB_ )
            MP = NUMROC( N, MB, MYPROW, DESCA( RSRC_ ), NPROW )
            NQ = NUMROC( N, NB, MYPCOL, DESCA( CSRC_ ), NPCOL )
            IF( WANTVT.EQ.1 ) THEN
               SIZEP = NUMROC( N, DESCVT( MB_ ), MYPROW,
     $                 DESCVT( RSRC_ ), NPROW )
            ELSE
               SIZEP = 0
            END IF
            IF( WANTU.EQ.1 ) THEN
               SIZEQ = NUMROC( N, DESCU( NB_ ), MYPCOL,
     $                 DESCU( CSRC_ ), NPCOL )
            ELSE
               SIZEQ = 0
            END IF
*
* Transmit MAX(NQ0, MP0).
*
            IF( MYPROW.EQ.0 .AND. MYPCOL.EQ.0 ) THEN
               MAXIM = MAX( NQ, MP )
               CALL IGEBS2D( DESCA( CTXT_ ), 'All', ' ', 1, 1, MAXIM,
     $                       1 )
            ELSE
               CALL IGEBR2D( DESCA( CTXT_ ), 'All', ' ', 1, 1, MAXIM, 1,
     $                       0, 0 )
            END IF
*
            WPDLANGE = MP
            WPDGEBRD = NB*( MP+NQ+1 ) + NQ
            WATOBD = MAX( MAX( WPDLANGE, WPDGEBRD ), MAXIM )
*
            WDBDSQR = MAX( 1, 2*N+( 2*N-4 )*MAX( WANTU, WANTVT ) )
            WPDORMBRQLN = MAX( ( NB*( NB-1 ) ) / 2, ( SIZEQ+MP )*NB ) +
     $                    NB*NB
            WPDORMBRPRT = MAX( ( MB*( MB-1 ) ) / 2, ( SIZEP+NQ )*MB ) +
     $                    MB*MB
            WBDTOSVD = N*( WANTU*NRU+WANTVT*NCVT ) +
     $                 MAX( WDBDSQR, MAX( WANTU*WPDORMBRQLN,
     $                 WANTVT*WPDORMBRPRT ) )
*
* Finally, calculate required workspace.
*
            LWMIN = 2 + 6*N + MAX( WATOBD, WBDTOSVD )
            WORK( 1 ) = DBLE( LWMIN )
*
            IF( WANTU.NE.1 .AND. .NOT.( LSAME( SV, 'L' ) .OR.
     $          LSAME( SV, 'A' ) ) ) THEN
               INFO = -1
            ELSE IF( WANTVT.NE.1 .AND. .NOT.( LSAME( SV, 'R' ) .OR.
     $               LSAME( SV, 'L' ) ) ) THEN
               INFO = -1
            ELSE IF( LWORK.LT.LWMIN .AND. LWORK.NE.-1 ) THEN
               INFO = -17
            END IF
*
         END IF
*
         IDUM1( 1 ) = WANTU
         IDUM1( 2 ) = WANTVT
         IF( LWORK.EQ.-1 ) THEN
            IDUM1( 3 ) = -1
         ELSE
            IDUM1( 3 ) = 1
         END IF
         IDUM2( 1 ) = 1
         IDUM2( 2 ) = 1
         IDUM2( 3 ) = 17
         CALL PCHK1MAT( N, 2, N, 2, IA, JA, DESCA, 6, 3, IDUM1, IDUM2,
     $                  INFO )
         IF( INFO.EQ.0 ) THEN
            IF( WANTU.EQ.1 ) THEN
               CALL PCHK1MAT( N, 2, N, 2, IU, JU, DESCU, 11, 0, IDUM1,
     $                        IDUM2, INFO )
            END IF
            IF( WANTVT.EQ.1 ) THEN
               CALL PCHK1MAT( N, 2, N, 2, IVT, JVT, DESCVT, 15, 0,
     $                        IDUM1, IDUM2, INFO )
            END IF
         END IF
*
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL PXERBLA( DESCA( CTXT_ ), 'PDGESVD3', -INFO )
         RETURN
      ELSE IF( LWORK.EQ.-1 ) THEN
         GO TO 40
      END IF
*
* Quick return if possible.
*
      IF( N.LE.0 )  GO TO 40
*
* Get machine constants.
*
      SAFMIN = PDLAMCH( DESCA( CTXT_ ), 'Safe minimum' )
      EPS = PDLAMCH( DESCA( CTXT_ ), 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = MIN( SQRT( BIGNUM ), ONE / SQRT( SQRT( SAFMIN ) ) )
*
* Scale matrix to allowable range, if necessary.
*
      ANRM = PDLANGE( '1', N, N, A, IA, JA, DESCA, WORK( INDWORK ) )
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
      END IF
*
      IF( ISCALE.EQ.1 ) THEN
         CALL PDLASCL( 'G', ONE, SIGMA, N, N, A, IA, JA, DESCA, INFO )
      END IF
*
      CALL PDGEBRD( N, N, A, IA, JA, DESCA, WORK( INDD ), WORK( INDE ),
     $              WORK( INDTAUQ ), WORK( INDTAUP ), WORK( INDWORK ),
     $              LLWORK, INFO )
*
* Copy D and E to all processes.
* Array D is in local array of dimension:
* LOCc(JA+MIN(M,N)-1) if M >= N; LOCr(IA+MIN(M,N)-1) otherwise.
* Array E is in local array of dimension
* LOCr(IA+MIN(M,N)-1) if M >= N; LOCc(JA+MIN(M,N)-2) otherwise.
*
* Distribute D
         CALL PDLARED1D( N+IOFFD, IA, JA, DESCA, WORK( INDD ),
     $                   WORK( INDD2 ), WORK( INDWORK ), LLWORK )
* Distribute E
         CALL PDLARED2D( N+IOFFE, IA, JA, DESCA, WORK( INDE ),
     $                   WORK( INDE2 ), WORK( INDWORK ), LLWORK )
*
* Prepare for calling PDBDSQR.
*
      UPLO = 'U'
*
      INDU = INDWORK
      INDV = INDU + N*NRU
      INDWORK = INDV + N*NCVT
*
      LDU = MAX( 1, NRU )
      LDVT = MAX( 1, N )
*
      CALL DESCINIT( DESCTU, N, N, 1, 1, 0, 0, CONTEXTC, LDU,
     $               INFO )
      CALL DESCINIT( DESCTVT, N, N, 1, 1, 0, 0, CONTEXTR, LDVT,
     $               INFO )
*
      IF( WANTU.EQ.1 ) THEN
         CALL PDLASET( 'Full', N, N, ZERO, ONE, WORK( INDU ), 1, 1,
     $                 DESCTU )
      ELSE
         NRU = 0
      END IF
*
      IF( WANTVT.EQ.1 ) THEN
         CALL PDLASET( 'Full', N, N, ZERO, ONE, WORK( INDV ), 1, 1,
     $                 DESCTVT )
      ELSE
         NCVT = 0
      END IF
*
      CALL DBDSQR( 'U', N, NCVT, NRU, 0, WORK( INDD2+IOFFD ),
     $             WORK( INDE2+IOFFE ), WORK( INDV ), N,
     $             WORK( INDU ), LDU, C, 1, WORK( INDWORK ), INFO )
*
* Redistribute elements of U and VT in the block-cyclic fashion.
*
      IF( WANTU.EQ.1 )
     $   CALL PDGEMR2D( N, N, WORK( INDU ), 1, 1, DESCTU, U, IU,
     $                  JU, DESCU, DESCU( CTXT_ ) )
*
      IF( WANTVT.EQ.1 )
     $   CALL PDGEMR2D( N, N, WORK( INDV ), 1, 1, DESCTVT, VT,
     $                  IVT, JVT, DESCVT, DESCVT( CTXT_ ) )
*
* Multiply Householder rotations from bidiagonalized matrix.
*
      IF( WANTU.EQ.1 )
     $   CALL PDORMBR( 'Q', 'L', 'N', N, N, N, A, IA, JA, DESCA,
     $                 WORK( INDTAUQ ), U, IU, JU, DESCU,
     $                 WORK( INDWORK ), LLWORK, INFO )
*
      IF( WANTVT.EQ.1 )
     $   CALL PDORMBR( 'P', 'R', 'T', N, N, N, A, IA, JA, DESCA,
     $                 WORK( INDTAUP ), VT, IVT, JVT, DESCVT,
     $                 WORK( INDWORK ), LLWORK, INFO )
*
* Copy singular values into output array S.
*
      DO 10 I = 1, N
         S( I ) = WORK( INDD2+IOFFD+I-1 )
   10 CONTINUE
*
* If matrix was scaled, then rescale singular values appropriately.
*
      IF( ISCALE.EQ.1 ) THEN
         CALL DSCAL( N, ONE / SIGMA, S, 1 )
      END IF
*
* Compare every ith eigenvalue, or all if there are only a few,
* across the process grid to check for heterogeneity.
*
      IF( N.LE.ITHVAL ) THEN
         J = N
         K = 1
      ELSE
         J = N / ITHVAL
         K = ITHVAL
      END IF
*
      DO 20 I = 1, J
         WORK( I+INDE ) = S( ( I-1 )*K+1 )
         WORK( I+INDD2 ) = S( ( I-1 )*K+1 )
   20 CONTINUE
*
      CALL DGAMN2D( DESCA( CTXT_ ), 'a', ' ', J, 1, WORK( 1+INDE ), J,
     $              1, 1, -1, -1, 0 )
      CALL DGAMX2D( DESCA( CTXT_ ), 'a', ' ', J, 1, WORK( 1+INDD2 ), J,
     $              1, 1, -1, -1, 0 )
*
      DO 30 I = 1, J
         IF( ( WORK( I+INDE )-WORK( I+INDD2 ) ).NE.ZERO ) THEN
            INFO = N + 1
         END IF
   30 CONTINUE
*
   40 CONTINUE
*
      CALL BLACS_GRIDEXIT( CONTEXTC )
      CALL BLACS_GRIDEXIT( CONTEXTR )
*
*     End of PDGESVD3
*
      RETURN
      END
